#include <avr/io.h>
#include <util/delay.h>
#include <avr/interrupt.h>

/*Intreruperea*/
ISR(PCINT3_vect) 
{
        PORTD &= ~(1 << PD7);
        if((PIND & (1 << PD2)) == 0) 
        {
            /*Aprind led-ul de pe placa*/
            PORTD |= (1 << PD7);
            int i;
            /*Mut bratul pana la switch incrementand
                pozitia acestuia */
            for (i = 97; i < 1000; i+= 40) 
            {
                    OCR1A = i;
                    _delay_ms(100);
            }
        }
}

void IO_init() 
{
        /* Setez pinul 7 ca output*/
        DDRD |= (1 << PD7);

        /* Setez pinul 2 ca input */
        DDRD &= ~(1 << PD2);
        /* Pornesc rezistenta de pull-up */
        PORTD |= (1 << PD2); 

        /* Activez intreruperile pentru PORTD, pin 2(PCINT26) */
        PCICR = (1 << PCIE3);
        PCMSK3 = (1 << PCINT26);
}

int main()
        {
    /* Activez intreruperile*/
    sei();
    
    IO_init();
    /* Configurez TIMER1*/
    TCCR1A|=(1<<COM1A1)|(1<<COM1B1)|(1<<WGM11);
    TCCR1B|=(1<<WGM13)|(1<<WGM12)|(1<<CS11)|(1<<CS10);
    ICR1=4999;
    DDRD|=(1<<PD4)|(1<<PD5);

    while(1)
    {

    }
    return 0;
}
